//------------------------------------------------------------------------------
// FFT NXif[^̏ꍇj
//		쐬ҁF O㒼C 2014/04/13 쐬C(c)O㒼
//------------------------------------------------------------------------------

#include "FftReal.hpp"

// RXgN^
FftReal::FftReal(const int16_t n) : N_FFT_(n)
{
	assert(n > 0);			// f[^ 0 ȉ̏ꍇɋI
	uint16_t pw2 = n;
	while ((pw2 & 0x1) == 0) pw2 = pw2 >> 1;
	assert(pw2 == 0x1);		// f[^Qׂ̂ł͂ȂꍇɋI

	wTable_ = new Complex[n/2];
	bTable_ = new uint32_t[n/2];	// TCY͒ʏ FFT  1/2
	u_ = new Complex[n];

// ]q̌vZ
	Complex arg = Complex(0, -6.28318531f/n);
	for (int k=0; k<n/2; k++) wTable_[k] = exp(arg*k);

// rbgtp
	int nHalf = n/2;
	bTable_[0] = 0;
	for (int m=1; m<n/2; m*=2)
	{
		for (int k=0; k<m; k++) bTable_[k+m] = bTable_[k] + nHalf;
		nHalf = nHalf/2;
	}
}

// fXgN^
FftReal::~FftReal()
{
	delete[] wTable_;
	delete[] bTable_;
	delete[] u_;
}

// FFT ̎s
void FftReal::Execute(const float x[], Complex y[])
{
	for (int n=0; n<N_FFT_; n++) u_[n] = x[n];

// Ō̒i
	uint16_t nHalf = N_FFT_/2;
	for (int stg=1; stg<N_FFT_/2; stg*=2)
	{
		uint16_t nHalf2 = nHalf*2;
		for (int kp=0; kp<N_FFT_; kp+=nHalf2)
		{
			uint16_t kx = 0;
			for (int k=kp; k<kp+nHalf; k++)
			{
				// o^tCZ
				Complex uTmp = u_[k+nHalf];
				u_[k+nHalf] = (u_[k] - uTmp)*wTable_[kx];
				u_[k] = u_[k] + uTmp;
				kx = kx + stg;
			}
		}
		nHalf = nHalf/2;
	}

// Ō̒ȉ
	y[0] = u_[0] + u_[1];
	y[N_FFT_/2] = u_[0] - u_[1];
	for (int k=2; k<N_FFT_; k+=2) u_[k] = u_[k] + u_[k+1];

// rbgt̕בւ
	for (int k=1; k<N_FFT_/2; k++) y[k] = u_[bTable_[k]];
}
