//------------------------------------------------------------------------------
//	|
//		쐬ҁFO㒼C2014/05/05 쐬C(c)O㒼 2014
//------------------------------------------------------------------------------

#include <cmath>
#include "Window.hpp"

// RXgN^
Window::Window(int nWidth, WinType type)
			  : N_DATA_(nWidth)
{
	float pi2N = 6.283185f/nWidth;
	float pi4N = 2*pi2N;

	wn = new float[nWidth];

	if (type == Hanning)
		for (int n=0; n<nWidth; n++)
			wn[n] = 0.5f - 0.5f*cosf(pi2N*n);
	if (type == Hamming)
		for (int n=0; n<nWidth; n++)
			wn[n] = 0.54f - 0.46f*cosf(pi2N*n);
	if (type == Blackman)
		for (int n=0; n<nWidth; n++)
			wn[n] = 0.42f - 0.5f*cosf(pi2N*n)
						  + 0.08f*cosf(pi4N*n);
}
